//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{ Form1->AutoSize = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{ TFileStream* fs;
  TSearchRec FileInf;

  if(OpenDialog1->Execute())
  { memset(rd_buf,0,FILESIZE);                    //      

    FilePathOpen=OpenDialog1->FileName;           //    
    DirPath = "";
    //       
    int done = FindFirst(DirPath, faAnyFile, FileInf);
    while (!done)
    { FilesTable->Add(FileInf.Name);
      done=FindNext(FileInf);
    }
    FindClose(FileInf);

    fs=new TFileStream(FilePathOpen,fmOpenRead);  //        
    SizeOfReadedFile=fs->Seek(0,soFromEnd);       //    
    if(SizeOfReadedFile>FILESIZE)
        SizeOfReadedFile=FILESIZE;                //         -    ,  
    fs->Seek(0,soFromBeginning);                  //     
    //-------------------------------
    fs->Read(rd_buf,SizeOfReadedFile);            //      
    delete fs;
    //---     ---
    Edit2->Text = OpenDialog1->FileName;

    //---  
    //---   - CITECT,  - VERSION 2,  - TREND HISTORY,  - ,  - ,  -  +  
    //---      ---
    StartStr[0]=0;                                //     
    int j=1;                                      //    
    for(int i=0; i<0x110; i++)                    //   
    { if(rd_buf[i]==0x0A && rd_buf[i+1]==0x0D)
      { StartStr[j]=i+2;        //  
        j++;                    //    
        if(j==6) i=0x110;       //    
      }
    }
    //---      ---
    LenghtStr[0]=StartStr[1]-StartStr[0]-2;
    LenghtStr[1]=StartStr[2]-StartStr[1]-2;
    LenghtStr[2]=StartStr[3]-StartStr[2]-2;
    LenghtStr[3]=StartStr[4]-StartStr[3]-2;
    LenghtStr[4]=StartStr[5]-StartStr[4]-2;
    LenghtStr[5]=0x110-StartStr[5]-2;

    //---        Ansi- ---
    char *TempArray1 = new char[LenghtStr[3]+1]; //   ,     +1
    memset(TempArray1,0,LenghtStr[3]+1);         //    
    for(int i=0; i<LenghtStr[3]; i++)
    { TempArray1[i]=rd_buf[StartStr[3]+i];       //      
    }
    TagStr=AnsiString(TempArray1);
    delete [] TempArray1;                        //  
    Form1->Label8->Caption = TagStr;             //     

    //---        ---
    StartTime.tm_sec = (rd_buf[StartStr[4]+17]-0x30)*10+(rd_buf[StartStr[4]+18]-0x30);
    StartTime.tm_min = (rd_buf[StartStr[4]+14]-0x30)*10+(rd_buf[StartStr[4]+15]-0x30);
    StartTime.tm_hour = (rd_buf[StartStr[4]+11]-0x30)*10+(rd_buf[StartStr[4]+12]-0x30);
    StartTime.tm_mday = (rd_buf[StartStr[4]+8]-0x30)*10+(rd_buf[StartStr[4]+9]-0x30);
    //---       ---
    int ReadedMonth = rd_buf[StartStr[4]+4+0]+rd_buf[StartStr[4]+4+1]+rd_buf[StartStr[4]+4+2]; //   
    switch (ReadedMonth)
    { case 281 : StartTime.tm_mon = 0;         // Jan
                 break;
      case 269 : StartTime.tm_mon = 1;         // Feb
                 break;
      case 288 : StartTime.tm_mon = 2;         // Mar
                 break;
      case 291 : StartTime.tm_mon = 3;         // Apr
                 break;
      case 295 : StartTime.tm_mon = 4;         // May
                 break;
      case 301 : StartTime.tm_mon = 5;         // Jun
                 break;
      case 299 : StartTime.tm_mon = 6;         // Jul
                 break;
      case 285 : StartTime.tm_mon = 7;         // Aug
                 break;
      case 296 : StartTime.tm_mon = 8;         // Sep
                 break;
      case 294 : StartTime.tm_mon = 9;         // Oct
                 break;
      case 307 : StartTime.tm_mon = 10;        // Nov
                 break;
      case 268 : StartTime.tm_mon = 11;        // Dec
                 break;
      default :    StartTime.tm_mon = 0;
    }
    StartTime.tm_year = (rd_buf[StartStr[4]+20]-0x30)*1000+(rd_buf[StartStr[4]+21]-0x30)*100+(rd_buf[StartStr[4]+22]-0x30)*10+(rd_buf[StartStr[4]+23]-0x30)-1900;
    StartTimeTicks = mktime(&StartTime);                 //         tm_wday, tm_yday
    Form1->Label6->Caption = asctime(&StartTime);        //   
    //---      ---
    EndTimeTicks = StartTimeTicks+(SizeOfReadedFile-0x110)/2;    //     
    struct tm *TempTime;
    TempTime = localtime(&EndTimeTicks);                         //       
    //---    
    EndTime.tm_sec = TempTime->tm_sec;
    EndTime.tm_min = TempTime->tm_min;
    EndTime.tm_hour = TempTime->tm_hour;
    EndTime.tm_mday = TempTime->tm_mday;
    EndTime.tm_mon = TempTime->tm_mon;
    EndTime.tm_year = TempTime->tm_year;
    EndTime.tm_wday = TempTime->tm_wday;
    EndTime.tm_yday = TempTime->tm_yday;
    EndTime.tm_isdst = TempTime->tm_isdst;
    Form1->Label12->Caption = asctime(&EndTime);         //   

    //    ( float, - 4 ,   0x78 )
    memcpy(&ScaleStart, &rd_buf[0x78], 4);
    Form1->Label9->Caption = FloatToStrF(ScaleStart, ffFixed, 7, 5); //  7,   5
    //    ( float, - 4 ,   0x7C )
    memcpy(&ScaleEnd, &rd_buf[0x7C], 4);
    Form1->Label10->Caption = FloatToStrF(ScaleEnd, ffFixed, 7, 5);  //  7,   5
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{  AboutBox->Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{ TFileStream* fs;
  short LRCF=0x0A0D;            //        
  unsigned char Sep=0x3B;       //  ( ";" )
  char* DateStr;                //      ASCII (24  + 0x0 - )
  AnsiString AStrTemp, AStrRaw; //     Ansi-
  AnsiString AStrDay, AStrMon;  //     Ansi-
  AnsiString FileNameStr;       //     
  char* StrTemp;                //       -
  int ActualDataSize;           //       
  short Number;                 //   
  float NumberF;                //     
  float TempVal, AverageVal;    //    float    
  int   PointsCounter;          //    (   )
  struct tm *TempTime;          //     

  //    
  TempTime = localtime(&StartTimeTicks);   //       
  //   
  AStrTemp = "0" + IntToStr(TempTime->tm_mday);         //  
  AStrDay = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
  AStrTemp = "0" + IntToStr(TempTime->tm_mon+1);        //  
  AStrMon = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
  FileNameStr = Form1->Label8->Caption + "_" + IntToStr(TempTime->tm_year+1900)+ AStrMon + AStrDay;
  TempTime = localtime(&EndTimeTicks);   //       
  //   
  AStrTemp = "0" + IntToStr(TempTime->tm_mday);         //  
  AStrDay = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
  AStrTemp = "0" + IntToStr(TempTime->tm_mon+1);        //  
  AStrMon = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
  FileNameStr += "-" + IntToStr(TempTime->tm_year+1900) + AStrMon + AStrDay + ".csv";
  Form1->SaveDialog1->FileName = FileNameStr;

  if(SaveDialog1->Execute())                       //     
  { fs=new TFileStream(SaveDialog1->FileName,fmCreate|fmOpenWrite);     //    
    FilePathSave=SaveDialog1->FileName;            //    

    fs->Write(&rd_buf[StartStr[0]],LenghtStr[0]);    //       (CITECT)
    fs->Write(" ",1);                                //    
    fs->Write(&rd_buf[StartStr[1]],LenghtStr[1]);    //       (VERSION 2)
    fs->Write(" ",1);                                //    
    fs->Write(&rd_buf[StartStr[2]],LenghtStr[2]);    //       (TREND HISTORY)
    fs->Write(&LRCF,2);                              //     
    fs->Write(": ",5);                            //    
    fs->Write(&rd_buf[StartStr[3]],LenghtStr[3]);    //       ()
    fs->Write(&LRCF,2);                              //     

    fs->Write(" ", 14);  //    
    fs->Write(&LRCF,2);                    //     

    fs->Write(" :   ", 17);    //    
    DateStr = asctime(&StartTime);         //  ASCII  
    fs->Write(DateStr,24);                 //      
    fs->Write(&LRCF,2);                    //     

    fs->Write(" :    ", 17);    //    
    DateStr = asctime(&EndTime);           //  ASCII  
    fs->Write(DateStr,24);                 //      
    fs->Write(&LRCF,2);                    //     

    AStrTemp = FloatToStrF(ScaleStart, ffFixed, 5, 5);  //      Ansi-
    StrTemp = new char[AStrTemp.Length() + 1 ];         //    char,   1  Ansi-
    strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
    fs->Write(" :    ", 17);    //    
    fs->Write(StrTemp,AStrTemp.Length());  //     
    fs->Write(&LRCF,2);                    //     
    delete StrTemp;                        //     char

    AStrTemp = FloatToStrF(ScaleEnd, ffFixed, 5, 5);  //      Ansi-
    StrTemp = new char[AStrTemp.Length() + 1 ];       //    char,   1  Ansi-
    strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
    fs->Write(" :     ", 17);    //    
    fs->Write(StrTemp,AStrTemp.Length());  //     
    fs->Write(&LRCF,2);                    //     
    delete StrTemp;                        //     char

    AStrTemp = Form1->ComboBox1->Text;     //      Ansi-
    StrTemp = new char[AStrTemp.Length() + 1 ];         //    char,   1  Ansi-
    strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
    fs->Write(" : ", 17);    //    
    fs->Write(StrTemp,AStrTemp.Length());  //     
    fs->Write(&LRCF,2);                    //     
    delete StrTemp;                        //     char

    //   ,          
    switch ( Form1->ComboBox1->ItemIndex )
    { case 0 : Divider=1;
               break;
      case 1 : Divider=5;
               break;
      case 2 : Divider=60;
               break;
      default : Divider=1;
    }
    ActualDataSize =(SizeOfReadedFile-0x110)/(2*Divider);      //     

    CurrentTimeTicks = StartTimeTicks;                         //    
    //      1  (2 ),        
    for(int i=0; i<ActualDataSize; i++)
    {   //  
        TempTime = localtime(&CurrentTimeTicks);   //       
        //  
        AStrTemp = "0" + IntToStr(TempTime->tm_mday);         //  
        AStrDay = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
        AStrTemp = "0" + IntToStr(TempTime->tm_mon+1);        //  
        AStrMon = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
        AStrTemp = IntToStr(TempTime->tm_year+1900)+"-"+AStrMon+"-"+AStrDay;
        StrTemp = new char[AStrTemp.Length() + 1 ];     //    char,   1  Ansi-
        strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
        fs->Write(StrTemp,AStrTemp.Length());  //    
        if(Form1->CheckBox1->Checked == true)
        {   fs->Write(&Sep,1);                 //    
        }
        else
        {   fs->Write(" ",1);                  //    
        }
        delete StrTemp;                        //     char
        //  
        AStrRaw = asctime(TempTime);            //      ASCII
        AStrTemp = AStrRaw.SubString(12,8);     //  
        StrTemp = new char[AStrTemp.Length() + 1 ];     //    char,   1  Ansi-
        strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
        fs->Write(StrTemp,AStrTemp.Length());  //    
        fs->Write(&Sep,1);                     //    
        delete StrTemp;                        //     char

        //  
        memcpy(&Number, &rd_buf[0x110+2*i*Divider], 2); //    
        if(Number < -32000 || Number > 32000)    //  
        {  fs->Write("n/a",3);                   //    n/a
        }
        else                                     //  
        {  NumberF = ScaleStart + (Number/32000.0)*(ScaleEnd-ScaleStart); //     

           AStrTemp = FloatToStrF(NumberF, ffFixed, 10, 5);//     Ansi- (  10,   5 )
           StrTemp = new char[AStrTemp.Length() + 1 ];     //    char,   1  Ansi-
           strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
           fs->Write(StrTemp,AStrTemp.Length());  //    
           delete StrTemp;                        //     char
        }
        fs->Write(&LRCF,2);                    //     

        //    
        CurrentTimeTicks += Divider;
    }
    delete fs;                             //   
    //---        ---
    Form1->Edit1->Text = FilePathSave;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{ TFileStream* fs;
  short LRCF=0x0A0D;            //        
  unsigned char Sep=0x3B;       //  ( ";" )
  char* DateStr;                //      ASCII (24  + 0x0 - )
  AnsiString AStrTemp, AStrRaw; //     Ansi-
  AnsiString AStrDay, AStrMon;  //     Ansi-
  AnsiString FileNameStr;       //     
  char* StrTemp;                //       -
  int ActualDataSize;           //       
  short Number;                 //   
  float NumberF;                //     
  float TempVal, AverageVal;    //    float    
  int   PointsCounter;          //    (   )
  struct tm *TempTime;          //     

  //    
  TempTime = localtime(&StartTimeTicks);   //       
  //   
  AStrTemp = "0" + IntToStr(TempTime->tm_mday);         //  
  AStrDay = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
  AStrTemp = "0" + IntToStr(TempTime->tm_mon+1);        //  
  AStrMon = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
  FileNameStr = Form1->Label8->Caption + "_hour_" + IntToStr(TempTime->tm_year+1900)+ AStrMon + AStrDay;
  TempTime = localtime(&EndTimeTicks);   //       
  //   
  AStrTemp = "0" + IntToStr(TempTime->tm_mday);         //  
  AStrDay = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
  AStrTemp = "0" + IntToStr(TempTime->tm_mon+1);        //  
  AStrMon = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
  FileNameStr += "-" + IntToStr(TempTime->tm_year+1900) + AStrMon + AStrDay + ".csv";
  Form1->SaveDialog1->FileName = FileNameStr;

  if(SaveDialog1->Execute())                       //     
  { fs=new TFileStream(SaveDialog1->FileName,fmCreate|fmOpenWrite);     //    
    FilePathSave=SaveDialog1->FileName;            //    

    fs->Write(&rd_buf[StartStr[0]],LenghtStr[0]);    //       (CITECT)
    fs->Write(" ",1);                                //    
    fs->Write(&rd_buf[StartStr[1]],LenghtStr[1]);    //       (VERSION 2)
    fs->Write(" ",1);                                //    
    fs->Write(&rd_buf[StartStr[2]],LenghtStr[2]);    //       (TREND HISTORY)
    fs->Write(&LRCF,2);                              //     
    fs->Write(": ",5);                            //    
    fs->Write(&rd_buf[StartStr[3]],LenghtStr[3]);    //       ()
    fs->Write(&LRCF,2);                              //     

    fs->Write(" ", 14);       //    
    fs->Write(&LRCF,2);                    //     

    fs->Write(" :   ", 17);    //    
    DateStr = asctime(&StartTime);         //  ASCII  
    fs->Write(DateStr,24);                 //      
    fs->Write(&LRCF,2);                    //     

    fs->Write(" :    ", 17);    //    
    DateStr = asctime(&EndTime);           //  ASCII  
    fs->Write(DateStr,24);                 //      
    fs->Write(&LRCF,2);                    //     

    AStrTemp = FloatToStrF(ScaleStart, ffFixed, 5, 5);  //      Ansi-
    StrTemp = new char[AStrTemp.Length() + 1 ];         //    char,   1  Ansi-
    strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
    fs->Write(" :    ", 17);    //    
    fs->Write(StrTemp,AStrTemp.Length());  //     
    fs->Write(&LRCF,2);                    //     
    delete StrTemp;                        //     char

    AStrTemp = FloatToStrF(ScaleEnd, ffFixed, 5, 5);  //      Ansi-
    StrTemp = new char[AStrTemp.Length() + 1 ];       //    char,   1  Ansi-
    strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
    fs->Write(" :     ", 17);    //    
    fs->Write(StrTemp,AStrTemp.Length());  //     
    fs->Write(&LRCF,2);                    //     
    delete StrTemp;                        //     char

    AStrTemp = Form1->ComboBox1->Text;     //      Ansi-
    StrTemp = new char[AStrTemp.Length() + 1 ];         //    char,   1  Ansi-
    strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
    fs->Write(" : ", 17);    //    
    fs->Write(StrTemp,AStrTemp.Length());  //     
    fs->Write(&LRCF,2);                    //     
    delete StrTemp;                        //     char

    //   ,          
    switch ( Form1->ComboBox1->ItemIndex )
    { case 0 : Divider=1;
               break;
      case 1 : Divider=5;
               break;
      case 2 : Divider=60;
               break;
      default : Divider=1;
    }
    ActualDataSize =(SizeOfReadedFile-0x110)/(2*Divider);      //     
    AverageVal = 0;                                            //    
    PointsCounter = 0;                                         //    

    CurrentTimeTicks = StartTimeTicks;                         //     
    //      1  (2 ),       
    for(int i=0; i<ActualDataSize; i++)                        //       ,  3599-
    {   //  
        if(PointsCounter == 0)                                 //    
        {  //  
           TempTime = localtime(&CurrentTimeTicks);    //       
           //  
           AStrTemp = "0" + IntToStr(TempTime->tm_mday);         //  
           AStrDay = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
           AStrTemp = "0" + IntToStr(TempTime->tm_mon+1);        //  
           AStrMon = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
           AStrTemp = IntToStr(TempTime->tm_year+1900)+"-"+AStrMon+"-"+AStrDay;
           StrTemp = new char[AStrTemp.Length() + 1 ];     //    char,   1  Ansi-
           strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
           fs->Write(StrTemp,AStrTemp.Length());  //    
           if(Form1->CheckBox1->Checked == true)
           {   fs->Write(&Sep,1);                 //    
           }
           else
           {   fs->Write(" ",1);                  //    
           }
           delete StrTemp;                        //     char
           //  
           AStrRaw = asctime(TempTime);            //      ASCII
           AStrTemp = AStrRaw.SubString(12,8);     //  
           StrTemp = new char[AStrTemp.Length() + 1 ];     //    char,   1  Ansi-
           strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
           fs->Write(StrTemp,AStrTemp.Length());  //    
           fs->Write(&Sep,1);                     //    
           delete StrTemp;                        //     char

           //  
           CurrentTimeTicks +=3600;               //  
           TempTime = localtime(&CurrentTimeTicks);   //       
           //  
           AStrTemp = "0" + IntToStr(TempTime->tm_mday);         //  
           AStrDay = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
           AStrTemp = "0" + IntToStr(TempTime->tm_mon+1);        //  
           AStrMon = AStrTemp.SubString(AStrTemp.Length()-1,2);  //   2 
           AStrTemp = IntToStr(TempTime->tm_year+1900)+"-"+AStrMon+"-"+AStrDay;
           StrTemp = new char[AStrTemp.Length() + 1 ];     //    char,   1  Ansi-
           strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
           fs->Write(StrTemp,AStrTemp.Length());  //    
           if(Form1->CheckBox1->Checked == true)
           {   fs->Write(&Sep,1);                 //    
           }
           else
           {   fs->Write(" ",1);                  //    
           }
           delete StrTemp;                        //     char
           //  
           AStrRaw = asctime(TempTime);            //      ASCII
           AStrTemp = AStrRaw.SubString(12,8);     //  
           StrTemp = new char[AStrTemp.Length() + 1 ];     //    char,   1  Ansi-
           strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
           fs->Write(StrTemp,AStrTemp.Length());  //    
           fs->Write(&Sep,1);                     //    
           delete StrTemp;                        //     char
        }

        //  
        memcpy(&Number, &rd_buf[0x110+2*i*Divider], 2); //    
        if(Number < -32000 || Number > 32000)    //  
        {  PointsCounter += Divider;             //  ,     ( - )
        }
        else                                     //  
        {  NumberF = ScaleStart + (Number/32000.0)*(ScaleEnd-ScaleStart); //     
           AStrTemp = FloatToStrF(NumberF, ffFixed, 10, 5);//     Ansi- (  10,   5 )
           TempVal = StrToFloat(AStrTemp);
           AverageVal += TempVal;                 //  
           PointsCounter += Divider;              // 
        }
        if(PointsCounter == 3600)
        {  AverageVal = AverageVal*Divider/3600;  //     (     )
           AStrTemp = FloatToStrF(AverageVal, ffFixed, 20, 15); //     Ansi- (  15,   15 )
           StrTemp = new char[AStrTemp.Length() + 1 ];     //    char,   1  Ansi-
           strcpy(StrTemp,AStrTemp.c_str());      //   Ansi-   char
           fs->Write(StrTemp,AStrTemp.Length());  //    
           delete StrTemp;                        //     char
           AverageVal = 0;                //  
           PointsCounter = 0;             //  
           fs->Write(&LRCF,2);                    //     
        }
    }
    delete fs;                             //   
    //---        ---
    Form1->Edit1->Text = FilePathSave;
  }
}
//---------------------------------------------------------------------------

